<?php
//=========================================================================================\\
// Copyright (C) WTStats.info, All rights reserved.	 http://www.wtstats.info			   \\
//=========================================================================================\\

if(!defined('ATSPHP')) {die('This file cannot be accessed directly.');}

class rankings extends base {
  function __construct() {
    global $CONF, $DB, $FORM, $LNG, $TMPL;

    // Get the category, default to no category
    if(!empty($FORM['cat'])) {
      $TMPL['category'] = $category_escaped = htmlspecialchars($FORM['cat']);
	  $category_sql = urldecode(mysql_real_escape_string($FORM['cat']));
      $category_sql = "AND category = '{$category_sql}'";
    } else {
      $TMPL['category'] = $LNG['main_all'];
      $category_sql = $category_escaped = '';
    }

    $TMPL['header'] = "{$LNG['main_header']} - {$TMPL['category']}";

    // Get the ranking method, default to pageviews
    $ranking_method = $CONF['ranking_method'];

    // Make ORDER BY clause
    $order_by = $this->rank_by($ranking_method)." DESC";

    // Figure out what rows we want, and SELECT them
    if (isset($FORM['start'])) {
      $start = intval($FORM['start']);
      if($start > 0) $start--;
	  if($start < 0) $start=0;
    } else {$start = 0;}

	list($numrows) = mysql_fetch_row(mysql_query("SELECT COUNT(*) FROM traffic_sites WHERE active = 1 {$category_sql};"));

// Pagination
$pagescount = ceil($numrows/$CONF['num_list']);
$page       = floor($start/$CONF['num_list']);

// Paginare
$txt['nav'] = $dots_after = $dots_before = '';
if ($pagescount > 1) {
    if (($page + 1) > 1) {
		$back = (($page - 1) * $CONF['num_list']) + 1;
		$txt['nav'] .= ' <a href="';
                  if($category_escaped) { $txt['nav'] .= "/cat/{$category_escaped}"; }
                  $txt['nav'] .= '/start/1" class="pagination" title="Prima Pagina">&lt;&lt;</a> ';
		$txt['nav'] .= ' <a href="';
                  if($category_escaped) { $txt['nav'] .= "/cat/{$category_escaped}"; }
                  $txt['nav'] .= '/start/'.$back.'" class="pagination" title="Pagina Anterioara">&lt;</a> ';
	}
    for ($page_number = 1; $page_number <= $pagescount; $page_number++) {
		$start_page = (($page_number - 1) * $CONF['num_list']) + 1;
        if(($page_number - 1) == $page) {
            $txt['nav'] .= ' <a href="';
                  if($category_escaped) { $txt['nav'] .= "/cat/{$category_escaped}"; }
                  $txt['nav'] .= '/start/'.$start_page.'" class="pagination_current" title="Pagina Curenta '. $page_number .'">'. $page_number .'</a> ';
		} elseif($page_number >= $page - 8 && $page_number <= $page + 8) {
            $txt['nav'] .= ' <a href="';
                  if($category_escaped) { $txt['nav'] .= "/cat/{$category_escaped}"; }
                  $txt['nav'] .= '/start/'.$start_page.'" class="pagination" title="Pagina '. $page_number .'">'. $page_number .'</a> ';
		} else {
			if ($page_number > $page && $dots_after != true) {
				$txt['nav'] .= ' ...'; $dots_after = true;
			} elseif ($page_number < $page && $dots_before != true) {
				$txt['nav'] .= ' ...'; $dots_before = true;
			}
		}
    }
    if(($page+1) < $pagescount) {
		$next = (($page+1) * $CONF['num_list']) + 1;
		$last = (($pagescount-1) * $CONF['num_list']) + 1;
            $txt['nav'] .= ' <a href="';
                  if($category_escaped) { $txt['nav'] .= "/cat/{$category_escaped}"; }
                  $txt['nav'] .= '/start/'.$next.'" class="pagination" title="Pagina Urmatoare">&gt;</a> ';
            $txt['nav'] .= ' <a href="';
                  if($category_escaped) { $txt['nav'] .= "/cat/{$category_escaped}"; }
                  $txt['nav'] .= '/start/'.$last.'" class="pagination" title="Ultima Pagina">&gt;&gt;</a> ';
	}
}

$TMPL['pagination'] = $txt['nav']?"<center>{$txt['nav']}</center>":'';

    $ranking_period = $CONF['ranking_period'];
    $is_main = ($TMPL['category']==$LNG['main_all']);
    $TMPL['rank'] = $start+1;
    $page_rank = 1;
    $TMPL['alt'] = 'alt';

	$result = $DB->select_limit("SELECT * FROM traffic_sites a JOIN traffic_stats b ON (a.id=b.id) WHERE active = 1 {$category_sql} ORDER BY {$order_by}", $CONF['num_list'], $start, __FILE__, __LINE__);
	
    if ($DB->num_rows($result)) {
      // All this $TMPL_original stuff is a hack to avoid doing an array_merge
      // on large arrays with conflicting keys, because that is very slow
      $TMPL_original = $TMPL;

      while($row = $DB->fetch_array($result)) {
        $TMPL_original['content'] = $TMPL['content'];
        $TMPL_original['alt'] = $TMPL['alt'];
        $TMPL_original['rank'] = $TMPL['rank'];
        $TMPL = array_merge($TMPL_original, $row);

        $TMPL['category_url'] = str_replace(' ', '+', $TMPL['category']);

        if($is_main) {
			if ($TMPL['old_rank'] > $TMPL['rank']) { $TMPL['up_down'] = 'up'; $LNG['up_down'] = $LNG['table_up']; }
			elseif ($TMPL['old_rank'] < $TMPL['rank']) { $TMPL['up_down'] = 'down'; $LNG['up_down'] = $LNG['table_down']; }
			else { $TMPL['up_down'] = 'neutral'; $LNG['up_down'] = $LNG['table_neutral']; }
        }  else { $TMPL['up_down'] = 'neutral'; $LNG['up_down'] = $LNG['table_neutral']; }
        $TMPL['alt'] = $TMPL['alt']?'':'alt';
		
		$TMPL['title'] = htmlspecialchars($TMPL['title'], ENT_QUOTES);
		$TMPL['description'] = htmlspecialchars($TMPL['description'], ENT_QUOTES);
		
		if(in_array('0',explode(',',$TMPL['blocked']))) {
			$TMPL['this_period'] = $TMPL['average'] = '?';
		} else {
			$TMPL['this_period'] = $TMPL["unq_{$ranking_method}_0_{$ranking_period}"];
			$TMPL['average'] = 0;
			for ($i = 0; $i < 10; $i++) {
				$TMPL['average'] += $TMPL["unq_{$ranking_method}_{$i}_{$ranking_period}"];
			}
			$TMPL['average'] = $TMPL['average'] / 10;
		}

        $TMPL['unq_pv_max_daily']   = $TMPL['unq_pv_0_daily'] > $TMPL['unq_pv_max_daily'] ? $TMPL['unq_pv_0_daily'] : $TMPL['unq_pv_max_daily'];
		$TMPL['tot_pv_max_daily']   = $TMPL['tot_pv_0_daily'] > $TMPL['tot_pv_max_daily'] ? $TMPL['tot_pv_0_daily'] : $TMPL['tot_pv_max_daily'];
		$TMPL['unq_pv_max_weekly']  = $TMPL['unq_pv_0_weekly'] > $TMPL['unq_pv_max_weekly'] ? $TMPL['unq_pv_0_weekly'] : $TMPL['unq_pv_max_weekly'];
		$TMPL['tot_pv_max_weekly']  = $TMPL['tot_pv_0_weekly'] > $TMPL['tot_pv_max_weekly'] ? $TMPL['tot_pv_0_weekly'] : $TMPL['tot_pv_max_weekly'];
		$TMPL['unq_pv_max_monthly'] = $TMPL['unq_pv_0_monthly'] > $TMPL['unq_pv_max_monthly'] ? $TMPL['unq_pv_0_monthly'] : $TMPL['unq_pv_max_monthly'];
		$TMPL['tot_pv_max_monthly'] = $TMPL['tot_pv_0_monthly'] > $TMPL['tot_pv_max_monthly'] ? $TMPL['tot_pv_0_monthly'] : $TMPL['tot_pv_max_monthly'];
		
		if($TMPL['rank_cache_time'] < $CONF['time'] && $TMPL['rank'] != $TMPL['rank_cache'] && $category_escaped == '') { 
			$rank_time_cache = $CONF['time']+1800;
			if($TMPL['rank_cache'])
				if($TMPL['rank'] < $TMPL['rank_cache'])
					mysql_unbuffered_query("UPDATE traffic_sites SET rank_cache = rank_cache+1, rank_cache_time = '{$rank_time_cache}' WHERE rank_cache BETWEEN '{$TMPL['rank']}' AND '{$TMPL['rank_cache']}'-1;");
				else 
					mysql_unbuffered_query("UPDATE traffic_sites SET rank_cache = rank_cache-1, rank_cache_time = '{$rank_time_cache}' WHERE rank_cache BETWEEN '{$TMPL['rank_cache']}'+1 AND '{$TMPL['rank']}';");
			mysql_unbuffered_query("UPDATE traffic_sites SET rank_cache = '{$TMPL['rank']}', rank_cache_time = '{$rank_time_cache}' WHERE id = {$TMPL['id']} LIMIT 1;"); 
		}
		
        $TMPL['content'] .= $this->do_skin('table_row');

        $TMPL['rank']++; $page_rank++;
      }
    }
	
    if (!isset($TMPL['content'])) { $TMPL['content'] = ''; }
    $TMPL['content'] = $this->do_skin('table_wrapper');
  }
}
?>
